import { Automata } from "../Automata";

export class AutomataSaveData {
    /**@type {String}*/author
    /**@type {boolean}*/isPrivate;
    /**@type {Automata}*/automata;

    constructor(automata,author,isPrivate=false){
        this.automata = automata;
        this.author = author;
        this.isPrivate = isPrivate;
    }

    /**
     * 
     * @param {AutomataSaveData} other 
     * @returns {boolean}
     */
    equals(other){
        return other.isPrivate == this.isPrivate && this.automata.equals(other.automata);
    }
    toString(){
        return "{\"isPrivate\":"+this.isPrivate+"\"automata\":"+this.automata.toString()+"}"
    }
    toShortJSON(){
        return {
            p: this.isPrivate ? 1 : 0,
            a: this.automata.toShortJSON()
        }
    }
}