import { world } from "@minecraft/server";
import { PhysicAut } from "./PhysicAut";
import { Database } from "./Database/Database";

let worldInitialized = false;

world.afterEvents.playerSpawn.subscribe(({player})=>{
    if(!worldInitialized){
        worldInitialized = true;
        for(let n of world.getDimension('minecraft:overworld').getEntities({
            families: [
                "floating_text"
            ]
        })) n.remove();
        let a = new PhysicAut(world.getDimension('minecraft:overworld'),{x: -21, y: -59, z: 169},"x",20,10,-1);
        a.setWallType('minecraft:iron_block');
        a.setTransitionsVisible(true);
        a.setStatesVisible(true);
        a.clearTransitionBlocks();
        PhysicAut.set(a,player);
        player.addTag("automata");
        Database.initialize();
    }
})


world.afterEvents.playerPlaceBlock.subscribe(({block,player})=>{
    if(player.hasTag('automata')){
        let ws = PhysicAut.get(player);
        if(ws) ws.placeBlock(block,player);
    }
})
world.afterEvents.playerBreakBlock.subscribe(({player,block,brokenBlockPermutation})=>{
    if(player.hasTag('automata')){
        let ws = PhysicAut.get(player);
        if(ws) ws.breakBlock(block,brokenBlockPermutation);
    }
})
world.beforeEvents.itemUseOn.subscribe((data)=>{
    if(data.source.hasTag('automata')){
        let ws = PhysicAut.get(data.source);
        if(ws) ws.itemUseOn(data);
    }
})
world.beforeEvents.itemUse.subscribe((data)=>{
    if(data.source.hasTag('automata')){
        let ws = PhysicAut.get(data.source);
        if(ws) ws.itemUse(data);
    }
})
world.afterEvents.entityHitEntity.subscribe(({damagingEntity,hitEntity})=>{
    if(damagingEntity.hasTag('automata') && hitEntity.typeId == "aut:transition_name"){
        let ws = PhysicAut.get(damagingEntity);
        if(ws) ws.interactWithName(damagingEntity,hitEntity);
    }
})